<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:art="http://artoftest.com/schemas/WebAiiDesignCanvas/1.0.0" xmlns:tt="http://microsoft.com/schemas/VisualStudio/TeamTest/2010" xmlns:watr="WebAiiTestResult">
	<!-- Created for NCoverExplorer by Grant Drake (see http://www.kiwidude.com/blog/)	-->
	<xsl:output method="html" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"/>
	
	<xsl:template match="/">
		
		<html>
			<head>
			    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
				<xsl:comment>arvato System S4M</xsl:comment>
				<title>arvato System / QA-Abteilung</title>
				<style>
					body 						{ font: small verdana, arial, helvetica; color:#000000;	}
					.coverageReportTable		{ font-size: 9px; }
					.reportHeader 				{ padding: 5px 8px 5px 8px; font-size: 12px; border: 1px solid; margin: 0px;	}
					.titleText					{ font-weight: bold; font-size: 12px; white-space: nowrap; padding: 0px; margin: 1px; }
					.subtitleText 				{ font-size: 9px; font-weight: normal; padding: 0px; margin: 1px; white-space: nowrap; }
					.projectStatistics			{ font-size: 10px; border-left: #649cc0 1px solid; white-space: nowrap;	width: 40%;	}
					.heading					{ font-weight: bold; }
					.mainTableHeaderLeft 		{ border: #dcdcdc 1px solid; font-weight: bold;	padding-left: 5px; }
					.mainTableHeader 			{ border-bottom: 1px solid; border-top: 1px solid; border-right: 1px solid;	text-align: center;	}
					.mainTableGraphHeader 		{ border-bottom: 1px solid; border-top: 1px solid; border-right: 1px solid;	text-align: left; font-weight: bold; }
					.mainTableCellItem 			{ background: #ffffff; border-left: #dcdcdc 1px solid; border-right: #dcdcdc 1px solid; padding-left: 10px; padding-right: 10px; font-weight: bold; font-size: 10px; }
					.mainTableCellData 			{ background: #ffffff; border-right: #dcdcdc 1px solid;	text-align: left;	white-space: nowrap; }
					.mainTableCellNumber 			{ background: #ffffff; border-right: #dcdcdc 1px solid;	text-align: center;	white-space: nowrap; }
					.mainTableCellObject 			{ background: #ffffff; border-right: #dcdcdc 1px solid; white-space: nowrap; }
					.mainTableCellPercent 		{ background: #ffffff; font-weight: bold; white-space: nowrap; text-align: right; padding-left: 10px; }
					.mainTableCellGraph 		{ background: #ffffff; border-right: #dcdcdc 1px solid; padding-right: 5px; }
					.mainTableCellBottom		{ border-bottom: #dcdcdc 1px solid;	}
					.childTableHeader 			{ border-top: 1px solid; border-bottom: 1px solid; border-left: 1px solid; border-right: 1px solid;	font-weight: bold; padding-left: 10px; }
					.childTableCellIndentedItem { background: #ffffff; border-left: #dcdcdc 1px solid; border-right: #dcdcdc 1px solid; padding-right: 10px; font-size: 10px; }
					.exclusionTableCellItem 	{ background: #ffffff; border-left: #dcdcdc 1px solid; border-right: #dcdcdc 1px solid; padding-left: 10px; padding-right: 10px; }
					.projectTable				{ background: #a9d9f7; border-color: #649cc0; }
					.primaryTable				{ background: #d7eefd; border-color: #a4dafc; }
					.secondaryTable 			{ background: #f9e9b7; border-color: #f6d376; }
					.secondaryChildTable 		{ background: #fff6df; border-color: #f5e1b1; }
					.exclusionTable				{ background: #fadada; border-color: #f37f7f; }
					.referenceTable				{ background: #FFE4B5; border-color: #FFC469; }
					.graphBarNotVisited			{ font-size: 2px; border:#9c9c9c 1px solid; background:#df0000; }
					.graphBarSatisfactory		{ font-size: 2px; border:#9c9c9c 1px solid;	background:#f4f24e; }
					.graphBarVisited			{ background: #00df00; font-size: 2px; border-left:#9c9c9c 1px solid; border-top:#9c9c9c 1px solid; border-bottom:#9c9c9c 1px solid; }
					.graphBarVisitedFully		{ background: #00df00; font-size: 2px; border:#9c9c9c 1px solid; }
					.blueCircle {width: 16px; height: 16px;background: #00df00; color: #ffffff;-moz-border-radius: 8px; -webkit-border-radius: 8px;}
					.redCircle {width: 16px; height: 16px;background: #ff0000; color: #ffffff;-moz-border-radius: 8px; -webkit-border-radius: 8px;}
					.yellowCircle {width: 16px; height: 16px;background: #FFD700; color: #ffffff;-moz-border-radius: 8px; -webkit-border-radius: 8px;}
					.hidden {display:none;}
				</style>
			</head>
			<body>
				<table class="coverageReportTable" cellpadding="2" cellspacing="0">
					<tbody>
							<xsl:apply-templates select="cruisecontrol"/>						
					</tbody>
				</table>
			</body>
		</html>
	</xsl:template>

  <!-- Main Project Section -->
  <xsl:template match="cruisecontrol">
    <xsl:call-template name="header"/>
    <xsl:call-template name="projectSummary"/>
    <xsl:call-template name="scenarioSummary"/>
    <xsl:call-template name="scenarioStepsSummary"/>
	<xsl:call-template name="informationReference"/>
  </xsl:template>
  
	<!-- Report Header -->
	<xsl:template name="header">
	<!--<xsl:variable name="Totalduration" select="sum(xs:time(./build/tt:TestRun/tt:Results/art:WebAiiTestResult/@duration))" />-->
				<tr>
					<td class="projectTable reportHeader" colspan="5">
						<table width="100%">
							<tbody>
								<tr>
									<td valign="top">
										<h1 class="titleText">AutomationTest Report - <xsl:value-of select="./build/tt:TestRun/@name" />&#160;&#160;</h1>
										<table cellpadding="1" class="subtitleText">
											<tbody>
												
                        <!--<tr>
                          <td class="heading">Duration:</td>
                          <td>
                            <xsl:value-of select= "$Totalduration"/>
                          </td>
                        </tr>-->
                        <tr>
                          <td class="heading">StartTime:</td>
							<td>
								<xsl:call-template name="formatDate">
									<xsl:with-param name="dateTime" select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/@startTime" />
								</xsl:call-template >
							</td>
                        </tr>
                      <!-- <tr>
                          <td class="heading">EndTime:</td>
                          <td>
							  <xsl:call-template name="formatDate">
								  <xsl:with-param name="dateTime" select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/@endTime" />
							  </xsl:call-template >
						  </td>
					  </tr>-->
					 <!-- <tr>
						  <td class="heading">Overall RresultTest:</td>
						  <td class="heading" align="left">
							  <xsl:call-template name="displayStepResult">
								  <xsl:with-param name="passed" select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/@outcome" />
                            </xsl:call-template >
                          </td>
                        </tr>-->
											</tbody>
										</table>
									</td>
									
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
	</xsl:template>
	
	<!-- Project Summary -->
	<xsl:template name="projectSummary">
	<label id="startSnip" class="hidden"></label>
	<xsl:variable name="pass" select="sum(./build/tt:TestRun/tt:ResultSummary/tt:Counters/@passed)" />
	<xsl:variable name="fail" select="sum(./build/tt:TestRun/tt:ResultSummary/tt:Counters/@failed)" />
	<xsl:variable name="percent" select="($pass * 100) div ($pass + $fail)" />
	
		<tr>
			<td colspan="4">&#160;</td>
		</tr>
		<tr>
			<td class="projectTable mainTableHeaderLeft">Test Project</td>
			<td class="projectTable mainTableGraphHeader">Passed Tests</td>
			<td class="projectTable mainTableGraphHeader">Failed Tests</td>
			<td class="projectTable mainTableGraphHeader" colspan="2">Passed tests(%)</td>
		</tr>
        <tr>
          <td class="mainTableCellBottom childTableCellIndentedItem"><xsl:value-of select="./integrationProperties/CCNetProject" /></td>
		  <td class="mainTableCellBottom mainTableCellData"> 
				<xsl:value-of select="$pass"/>
		  </td>		  
		  <td class="mainTableCellBottom mainTableCellData"> 
				<xsl:value-of select="$fail"/>
		  </td>
          <!--<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="./build/tt:TestRun/tt:ResultSummary/tt:Counters/@passed"/></td>-->
          <!-- <td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="./build/tt:TestRun/tt:ResultSummary/tt:Counters/@failed"/></td>-->
          <td class="mainTableCellBottom mainTableCellPercent">
          
          <!-- xsl:value-of select="concat(format-number(($passed * 100) div ($passed + $failed),'#0.0'), ' %')" -->

			  <xsl:value-of select="concat(format-number($percent, '#0.0'), ' %')" />
          
          </td>
          
          
		  <!--<td class="mainTableCellBottom mainTableCellPercent"><xsl:value-of select="concat(format-number((./build/tt:TestRun/tt:ResultSummary/tt:Counters/@passed * 100) div (./build/tt:TestRun/tt:ResultSummary/tt:Counters/@passed +./build/tt:TestRun/tt:ResultSummary/tt:Counters/@failed),'#0.0'), ' %')"/></td>-->
          <td class="mainTableCellBottom mainTableCellGraph">
            <xsl:call-template name="detailPercent">
              <xsl:with-param name="coverage" select="$percent" />
              <xsl:with-param name="scale" select="150" />
            </xsl:call-template>
          </td>
        </tr>
		<label id="endSnip" class="hidden"/>
	</xsl:template>
		
	<!-- Scenarios Summary -->
	<xsl:template name="scenarioSummary">

<xsl:value-of select="./integrationProperties/CCNetProject" />
		<tr>
			<td colspan="3">&#160;</td>
		</tr>
		<tr>
			<td class="primaryTable mainTableHeaderLeft">Order</td>	
			<td class="primaryTable mainTableGraphHeader">TestName</td>
			<td class="primaryTable mainTableGraphHeader">Duration</td>
			<td class="primaryTable mainTableGraphHeader">TestResult</td>
		</tr>				
    
		<xsl:for-each select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult">
			<tr>
				<td class="mainTableCellBottom childTableCellIndentedItem" align="center"><xsl:value-of select="position()"/></td>  
		
				<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="./@testName"/></td>
				<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="./@duration"/></td>
				<td class="mainTableCellBottom mainTableCellObject" align="center">
					<xsl:call-template name="displayStepResult">
						<xsl:with-param name="passed" select="./@outcome" />
					</xsl:call-template >
				</td>
			</tr>      
		</xsl:for-each>
		
	   <!-- <xsl:for-each select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/WebAiiTestResult/DataIterationResults/Item/Iteration">
						<tr>
						    <td class="secondaryTable mainTableHeaderLeft">Iteration</td>
							<td class="secondaryTable mainTableHeaderLeft"><xsl:value-of  select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/WebAiiTestResult/DataIterationResults/Item/Iteration"/> </td>    
						</tr>      
		</xsl:for-each>		-->
		


	</xsl:template>
  
  <!-- Steps per Scenario Summary -->
  <xsl:template name="scenarioStepsSummary">
		<xsl:for-each select="./build/tt:TestRun/tt:Results/art:WebAiiTestResult/WebAiiTestResult">
				<tr>
					<td colspan="5">&#160;</td>
				</tr>
				<tr>
					<td class="secondaryTable mainTableHeaderLeft">Test Name</td>
					<td class="secondaryTable mainTableGraphHeader">Start Time</td>
					<td class="secondaryTable mainTableGraphHeader">End Time</td>
					<td class="secondaryTable mainTableGraphHeader">Duration</td>
					<td class="primaryTable mainTableHeaderLeft">Result</td>
				</tr>
      <tr>
        <td class="mainTableCellBottom childTableCellIndentedItem"><xsl:value-of select="../@testName"/></td>
		<td class="mainTableCellBottom mainTableCellData">
			  <xsl:call-template name="formatDate">
				  <xsl:with-param name="dateTime" select="../@startTime" />
			  </xsl:call-template >
		</td>
        <td class="mainTableCellBottom mainTableCellData">
			<xsl:call-template name="formatDate">
				<xsl:with-param name="dateTime" select="../@endTime" />
			</xsl:call-template >
		</td>
		<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="../@duration"/></td>
	  <td class="mainTableCellBottom mainTableCellObject" align="left">
		  <xsl:call-template name="displayStepResult">
			  <xsl:with-param name="passed" select="./ResultType" />
		  </xsl:call-template >
	  </td>
	  </tr>
	  <tr>
        <td class="secondaryChildTable childTableHeader" colspan="5">Steps</td>
      </tr>
		  <xsl:for-each select="./AutomationStepResults/Item">				  
						  <tr>
							  <td class="mainTableCellBottom childTableCellIndentedItem" align="right">
								  <xsl:call-template name="displayStepResult">
									  <xsl:with-param name="passed" select="./ResultType" />
								  </xsl:call-template >
							  </td>
							  <td class="mainTableCellBottom mainTableCellNumber">
								  <xsl:value-of select="./Order"/>
							  </td>
							  <td class="mainTableCellBottom mainTableCellData" colspan="4">
								  <xsl:value-of select="./StepDescription"/>
							  </td>
							 <!-- <td class="mainTableCellBottom mainTableCellData" >
								  <xsl:value-of select="./ExecutionException"/>
							  </td>-->
							  <td class="mainTableCellBottom mainTableCellData" >
								  <xsl:value-of select="./ExecutionException/ExceptionMessage"/>
							  </td>								  
						  </tr>
						  
				<xsl:for-each select="./innerResult/AutomationStepResults/Item">
					   	<tr>
							  <td class="mainTableCellBottom childTableCellIndentedItem" align="right">
								  <xsl:call-template name="displayStepResult">
									  <xsl:with-param name="passed" select="./ResultType" />
								  </xsl:call-template >
							  </td>
							  <td class="mainTableCellBottom mainTableCellNumber">
								  <xsl:value-of select="./Order"/>
							  </td>
							  <td class="mainTableCellBottom mainTableCellData" colspan="4" >
								  <xsl:value-of select="./StepDescription"/>
							  </td>

						</tr>
						  
						 <xsl:for-each select="./innerResult/AutomationStepResults/Item">
					   	  <tr>
							  <td class="mainTableCellBottom childTableCellIndentedItem" align="right">
								  <xsl:call-template name="displayStepResult">
									  <xsl:with-param name="passed" select="./ResultType" />
								  </xsl:call-template >
							  </td>
							  <td class="mainTableCellBottom mainTableCellNumber">
								  <xsl:value-of select="./Order"/>
							  </td>
							  <td class="mainTableCellBottom mainTableCellData" colspan="4" >
								  <xsl:value-of select="./StepDescription"/>
							  </td>

						  </tr>
						</xsl:for-each>
			    </xsl:for-each>
				
		  </xsl:for-each>
		  
		  <xsl:for-each select="./NotRunStepDescriptions/Item">

				<tr>
					<td class="mainTableCellBottom childTableCellIndentedItem" align="right">
						<xsl:call-template name="displayStepResult">
							<xsl:with-param name="passed" select="'Null'" />
						</xsl:call-template >
					</td>
					<td class="mainTableCellBottom mainTableCellNumber">
						<xsl:value-of select="position()+ ../../ExecutingTestStepCount"/>
					</td>
					<td class="mainTableCellBottom mainTableCellData" colspan="4" >
						<xsl:value-of select="child::node()[1]"/>
					</td>

				</tr>


			</xsl:for-each>	
		</xsl:for-each>
	</xsl:template>

	<!-- Information Reference -->
	<xsl:template name="informationReference">
		<tr>
			<td colspan="3">&#160;</td>
		</tr>
		<tr>
			<td class="referenceTable mainTableHeaderLeft">Color</td>
			<td class="referenceTable mainTableGraphHeader">Meaning of color</td>
		</tr>
		<tr>
			<td class="mainTableCellBottom childTableCellIndentedItem" align="center">
				<xsl:call-template name="displayStepResult">
					<xsl:with-param name="passed" select="'Passed'" />
				</xsl:call-template >
			</td>
			<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="'Tests/Steps are passed'"/></td>
		</tr>
		<tr>
			<td class="mainTableCellBottom childTableCellIndentedItem" align="center">
				<xsl:call-template name="displayStepResult">
					<xsl:with-param name="passed" select="'Failed'" />
				</xsl:call-template >
			</td>
			<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="'Tests/Steps are failed'"/></td>
		</tr>
		<tr>
			<td class="mainTableCellBottom childTableCellIndentedItem" align="center">
				<xsl:call-template name="displayStepResult">
					<xsl:with-param name="passed" select="'Null'" />
				</xsl:call-template >
			</td>
			<td class="mainTableCellBottom mainTableCellData"><xsl:value-of select="'Steps did not run'"/></td>
		</tr>
	</xsl:template>
	

  <!-- Draw Circle for Steps -->
  <xsl:template name="displayStepResult">
    <xsl:param name="passed" />
    <table cellpadding="0" cellspacing="0">
      <tbody>
        <tr>
          <td height="14" >
            <div>
              <xsl:attribute name="class">
                <xsl:if test="($passed = 'Passed') or ($passed ='Passed') or $passed ='Pass'">blueCircle</xsl:if>
                <xsl:if test="($passed = 'Failed') or ($passed ='Failed') or $passed ='Fail'">redCircle</xsl:if>
				<xsl:if test="($passed = 'Null') or ($passed ='null')">yellowCircle</xsl:if>  
              </xsl:attribute>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </xsl:template>
  
  <!-- Draw % Green/Red/Yellow Bar -->
  <xsl:template name="detailPercent">
    <xsl:param name="coverage" />
    <xsl:param name="scale" />
    <table cellpadding="0" cellspacing="0">
      <tbody>
        <tr>
          <!--<td class="mainTableCellPercent"><xsl:value-of select="concat(format-number($coverage,'#0.0'), ' %')" /></td>-->
          <td class="graphBarVisited" height="14">
            <xsl:attribute name="width">
              <xsl:value-of select="format-number($coverage div 100 * $scale, '0') " />
            </xsl:attribute>
          </td>
          <td height="14">
            <xsl:attribute name="class">
              <xsl:if test="$coverage &gt;= 70">graphBarSatisfactory</xsl:if>
              <xsl:if test="$coverage &lt; 70">graphBarNotVisited</xsl:if>
            </xsl:attribute>
            <xsl:attribute name="width">
              <xsl:value-of select="format-number(((100-$coverage) * $scale) div 100, '0')" />
            </xsl:attribute>
          </td>
        </tr>        
      </tbody>
    </table>
  </xsl:template>

	<xsl:template name="formatDate">
		<xsl:param name="dateTime" />
		<xsl:variable name="date" select="substring-before($dateTime, 'T')" />
		<xsl:variable name="year" select="substring-before($date, '-')" />
		<xsl:variable name="month" select="substring-before(substring-after($date, '-'), '-')" />
		<xsl:variable name="day" select="substring-after(substring-after($date, '-'), '-')" />
		<xsl:variable name="time" select="substring-after($dateTime,'T')" />
		<xsl:variable name="hh" select="substring($time,1,2)" />
		<xsl:variable name="mm" select="substring($time,4,2)" />
		<xsl:variable name="ss" select="substring($time,7,2)" />
		<xsl:value-of select="concat($day, '-', $month, '-', $year,' ',$hh,':',$mm,':',$ss)" />
	</xsl:template>



</xsl:stylesheet>